/*
 * FullScreenManager - A unified API to use the fullscreen mode of various modern browsers
 *
 * Copyright (c) 2014-2015, Jean-Philippe Côté
 *
 * For documentation, updates and examples, visit:
 *
 *    http://cote.cc/projects/fullscreenmanager
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify,
 * merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies
 * or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
!function(a){"use strict";function b(){function a(a){Object.keys(f._apiMap).forEach(function(b){f._apiMap[b]=f._apiMap[b][a]})}function b(){null===f._element?(f._element=document[f._apiMap.fullscreenElement],f.element.classList.add(f.cssClass),f.doNotAlterCss||(f._savedState.height=f._element.style.height,f._savedState.width=f._element.style.width,f._savedState.display=f._element.style.display,f._savedState["-webkit-margin-before"]=f._element.style["-webkit-margin-before"],f._savedState["-webkit-margin-after"]=f._element.style["-webkit-margin-after"],f._element.style.height="100%",f._element.style.width="100%",f._element.style.display="block",f._element.style["-webkit-margin-before"]=0,f._element.style["-webkit-margin-after"]=0)):(f.doNotAlterCss||(f._element.style.height=f._savedState.height,f._element.style.width=f._savedState.width,f._element.style.display=f._savedState.display,f._savedState.height="",f._savedState.width="",f._savedState.display="",f._element.style["-webkit-margin-before"]=f._savedState["-webkit-margin-before"],f._element.style["-webkit-margin-after"]=f._savedState["-webkit-margin-after"]),f.element.classList.remove(f.cssClass),f._element=null);var a=f.active?f.ACTIVATION:f.DEACTIVATION;if(f._handlers[a]&&f._handlers[a].length>0)for(var b=0;b<f._handlers[a].length;b++){var c=f._handlers[a][b];c.listener({type:a,target:f,data:c.data})}}function c(a){for(var b=0;b<f._handlers.error.length;b++){var c=f._handlers.error[b];c.listener({type:f.ERROR,target:f,error:a,data:c.data})}}function d(){}function e(){for(var e=0;e<f._apiMap.requestFullscreen.length;e++)if(document.documentElement[f._apiMap.requestFullscreen[e]]){a(e);break}if(!("string"==typeof f._apiMap.requestFullscreen||f._apiMap.requestFullscreen instanceof String))throw"The FullScreenManager library is not supported on this browser.";document.addEventListener(f._apiMap.fullscreenchange,b),document.addEventListener(f._apiMap.fullscreenerror,c),window.addEventListener("resize",d)}Object.defineProperties(this,{_cssClass:{enumerable:!1,writable:!0,value:"fullscreen"},_element:{enumerable:!1,writable:!0,value:null},_handlers:{enumerable:!1,value:{activation:[],deactivation:[],error:[]}},_savedState:{enumerable:!1,value:{height:"",width:"",display:"","-webkit-margin-before":0,"-webkit-margin-after":0}},_apiMap:{enumerable:!1,value:{requestFullscreen:["requestFullscreen","webkitRequestFullscreen","mozRequestFullScreen","msRequestFullscreen","oRequestFullScreen","webkitRequestFullScreen"],exitFullscreen:["exitFullscreen","webkitExitFullscreen","mozCancelFullScreen","msExitFullscreen","oExitFullscreen","webkitCancelFullScreen"],fullscreenElement:["fullscreenElement","webkitFullscreenElement","mozFullScreenElement","msFullscreenElement","oFullscreenElement","webkitCurrentFullScreenElement"],fullscreenEnabled:["fullscreenEnabled","webkitFullscreenEnabled","mozFullScreenEnabled","msFullscreenEnabled","oFullscreenEnabled","webkitCancelFullScreen"],fullscreenchange:["fullscreenchange","webkitfullscreenchange","mozfullscreenchange","MSFullscreenChange","oFullscreenChange","webkitfullscreenchange"],fullscreenerror:["fullscreenerror","webkitfullscreenerror","mozfullscreenerror","MSFullscreenError","oFullscreenError","webkitfullscreenerror"]}},active:{enumerable:!0,get:function(){return null!==this._element}},available:{enumerable:!0,get:function(){return document[this._apiMap.fullscreenEnabled]}},cssClass:{enumerable:!0,get:function(){return this._cssClass},set:function(a){this.active&&(this.element.classList.remove(this._cssClass),this.element.classList.add(a)),this._cssClass=a}},doNotAlterCss:{enumerable:!0,writable:!0,value:!1},element:{enumerable:!0,get:function(){return this._element}},keyboardInputAllowed:{enumerable:!0,get:function(){return"undefined"!=typeof Element&&"ALLOW_KEYBOARD_INPUT"in Element}},version:{enumerable:!1,get:function(){return"1.0.0-alpha.26"}}});var f=this;e()}b.prototype.activate=function(a){return this.available?(("string"==typeof a||a instanceof String)&&document.getElementById(a)?a=document.getElementById(a):a instanceof Element||(a=document.documentElement),/5\.1[\.\d]* Safari/.test(navigator.userAgent)?a[this._apiMap.requestFullscreen]():a[this._apiMap.requestFullscreen](this.keyboardInputAllowed&&"undefined"!=typeof Element&&"ALLOW_KEYBOARD_INPUT"in Element),this):null},b.prototype.addEventListener=function(a,b,c){var d={listener:b,data:c};return this._handlers[a].push(d),this},b.prototype.deactivate=function(){return document[this._apiMap.exitFullscreen](),this},b.prototype.hasEventListener=function(a,b){if(a&&b){for(var c=0;c<this._handlers[a].length;c++)if(this._handlers[a][c].listener===b)return!0}else{if(a)return this._handlers[a].length>0;for(var d in this._handlers)if(this._handlers.hasOwnProperty(d)&&this._handlers[d].length>0)return!0}return!1},b.prototype.removeEventListener=function(a,b){if(a&&b)for(var c=this._handlers[a].length-1;c>=0;c--)this._handlers[a][c].listener===b&&this._handlers[a].splice(c,1);else if(a)this._handlers[a]=[];else for(var d in this._handlers)this._handlers.hasOwnProperty(d)&&(this._handlers[d]=[]);return this},b.prototype.toggle=function(a){return this.active?this.deactivate():this.activate(a)},"function"==typeof define&&define.amd?define([],function(){return new b}):a.FullScreenManager||(a.FullScreenManager=new b)}(this);